#include "VRML Viewpoints.h"

BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG :
		SetDlgEditTextWithCaretToEnd(hDlg,IDC_EMAIL_ADDRESS,"VRML_Viewpoints@virtualflower.co.uk");
		SetDlgEditTextWithCaretToEnd(hDlg,IDC_HOME_PAGE,"virtualflower.co.uk/vv/");
		return TRUE ;
	case WM_COMMAND :
		switch (LOWORD (wParam))
		{
		case IDOK :
		case IDCANCEL :
			EndDialog (hDlg, 0) ;
			return TRUE ;
		}
		break ;
	}
	return FALSE ;
}

void UpdateDialogEdits(char only_do_idd,HWND hwnd,WORD idd)
{
	UINT uText;
	static char processing_update_dialog_edits;
#define IF_PROCESS_IDD(idd_eq_IDD) if((only_do_idd&&(idd_eq_IDD))||(!only_do_idd&&!(idd_eq_IDD)))
	if(processing_update_dialog_edits)
		return;
	processing_update_dialog_edits=1;
	if(hDlgVRMLViewpoints)
	{
		IF_PROCESS_IDD(idd==IDC_VIEW_TO)
		{
			double *view_array=view_to;
			dlg_szEdit[0]='\0';
			uText=0;
			strcatDoubleArray(&uText,MAX_SZEDIT,dlg_szEdit,view_array,1/*multiplier*/,0/*first_value_only_if_repeats*/,WORLD_DIMENSION);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEW_TO,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_VIEW_FROM)
		{
			double *view_array=view_from;
			dlg_szEdit[0]='\0';
			uText=0;
			strcatDoubleArray(&uText,MAX_SZEDIT,dlg_szEdit,view_array,1/*multiplier*/,0/*first_value_only_if_repeats*/,WORLD_DIMENSION);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEW_FROM,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_VIEWPOINT_NAME)
		{
			strcpy(dlg_szEdit,szViewpointName);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEWPOINT_NAME,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_VIEW_TILT)
		{
			if((fabs(view_tilt))<1e-6)
				view_tilt=0;
				sprintf(dlg_szEdit,TEXT("%.*g"),precision,view_tilt*angles_mult);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEW_TILT,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_VIEW_FIELD_OF_VIEW)
		{
			sprintf(dlg_szEdit,TEXT("%.*g"),precision,view_field_of_view*angles_mult);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEW_FIELD_OF_VIEW,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_VIEWPOINT)
		{
			char szViewPoint2[MAX_SZVIEWPOINTNAME+MAX_VIEWPOINT_BODY]; 
			MakeViewpoint(szViewPoint);
			UnpackReturns(szViewPoint2,szViewPoint,MAX_SZVIEWPOINTNAME+MAX_VIEWPOINT_BODY);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_VIEWPOINT,szViewPoint2);
		}
		IF_PROCESS_IDD(idd==IDC_PRECISION)
		{
			sprintf(dlg_szEdit,TEXT("%d"),precision);
			SetDlgEditTextWithCaretToEnd(hDlgVRMLViewpoints,IDC_PRECISION,dlg_szEdit);
		}
		IF_PROCESS_IDD(idd==IDC_RADIO_RADIANS||idd==IDC_RADIO_DEGREES||idd==IDC_RADIO_WHOLE_TURNS)
		{
			SendMessageForID(hDlgVRMLViewpoints,IDC_RADIO_RADIANS,BM_SETCHECK,angles_in==RADIANS?1:0,0);
			SendMessageForID(hDlgVRMLViewpoints,IDC_RADIO_DEGREES,BM_SETCHECK,angles_in==DEGREES?1:0,0);
			SendMessageForID(hDlgVRMLViewpoints,IDC_RADIO_WHOLE_TURNS,BM_SETCHECK,angles_in==WHOLE_TURNS?1:0,0);
		}
		IF_PROCESS_IDD(idd==IDC_CHECK_SAVE_VALUES)
		{
			SendMessageForID(hDlgVRMLViewpoints,IDC_CHECK_SAVE_VALUES,BM_SETCHECK,save_values?1:0,0);
		}
	}
	processing_update_dialog_edits=0;
}

char StartProcessing(WORD id)
//if non zero return, needs to be paired with EndProcessing(..) or ShortEndProcessing();
{
	if(processing[(id-FIRST_PROCESSING_ID)%MAX_PROCESSING])
		return 0;
	processing[(id-FIRST_PROCESSING_ID)%MAX_PROCESSING]=1;
	return 1;
}

#define EndProcessing(id) (processing[(id-FIRST_PROCESSING_ID)%MAX_PROCESSING]=0)

char findszEdit(HWND hwnd, WPARAM wParam,char *dlg_szEdit,int max_dlg_szEdit,WORD id,char check_for_all_white_space)
{
	if(edits_updated&&HIWORD(wParam)==EN_UPDATE)
	{
		if(!StartProcessing(id))
			return 0;
		if(global_szEdit_ok)
			strcpy(dlg_szEdit,global_szEdit);
		else
			GetDlgItemText(hwnd,id,dlg_szEdit,(int)max_dlg_szEdit);
		if(!check_for_all_white_space||!is_white_space_sz(dlg_szEdit))
			return 1;
		EndProcessing(id);
		return 0;
	}
	return 0;
}

BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		{
			hDlgVRMLViewpoints=hwnd;
			SetIniDefaults(hwnd);
			UpdateDialogEdits(0,hwnd,0);
			edits_updated=1;
			if(ReadIniFile())
				save_values=1;
			UpdateDialogEdits(1,hwnd,IDC_CHECK_SAVE_VALUES);
			SetClassLong(hwnd,GCL_HICON,(int)LoadIcon(hInstance,"VRMLVIEWPOINTS"));
 		return TRUE ;
		}
	case WM_COMMAND:
		{
   WORD idc=LOWORD(wParam);
   if(idc_mid_update==idc)
    break;
   idc_mid_update=idc;
			switch(idc)
			{
		  case IDC_CHECK_SAVE_VALUES:
					save_values=save_values?0:1;
					break;
				case IDC_RADIO_RADIANS:
	 		case IDC_RADIO_DEGREES:
	 		case IDC_RADIO_WHOLE_TURNS:
					if(HIWORD(wParam)!=BN_CLICKED)
						break;
					switch(idc)
					{
	 			case IDC_RADIO_RADIANS:angles_in=RADIANS;break;
	 			case IDC_RADIO_DEGREES:angles_in=DEGREES;break;
	 			case IDC_RADIO_WHOLE_TURNS:angles_in=WHOLE_TURNS;break;
					}
					SET_ANGLES_MULT
		 		UpdateDialogEdits(0,hwnd,0);
					break;
				case IDC_PRECISION:
					if(findszEdit(hwnd,wParam,dlg_szEdit,MAX_SZEDIT,IDC_PRECISION,1/*check_for_all_white_space*/))
					{
 					precision=(int)slong_double(dlg_szEdit,precision);
						EndProcessing(idc);
						if(precision>1)//because get precision==1 on way to making it 12 while editing it
							UpdateDialogEdits(0,hwnd,0);
						else
							UpdateDialogEdits(1,hwnd,IDC_VIEWPOINT);
					}
					break;
				case IDC_BUTTON_COPY_VIEWPOINT_TO_CLIPBOARD:
					{
					GLOBALHANDLE hGlobalMemory;
					TCHAR *szGlobalMemory;
					/*Copy viewpoint to clipboard*/
					hGlobalMemory=GlobalAlloc(GHND|GMEM_SHARE,(DWORD)(strlen(szViewpointName)+MAX_VIEWPOINT_BODY)); 
					if(hGlobalMemory!=NULL)
						{
						szGlobalMemory=GlobalLock(hGlobalMemory);
						GetDlgItemText(hwnd,IDC_VIEWPOINT,dlg_szEdit,(int)MAX_SZEDIT);
						//MakeViewpoint(szViewPoint);
						UnpackReturns(szGlobalMemory,dlg_szEdit,MAX_SZVIEWPOINTNAME+MAX_VIEWPOINT_BODY);
						GlobalUnlock(hGlobalMemory); 
						OpenClipboard(hwnd);
						EmptyClipboard();
						SetClipboardData(CF_TEXT,hGlobalMemory);
						CloseClipboard();
						}
					}
					break;
				case IDC_VIEW_TO:
				case IDC_VIEW_FROM:
					if(findszEdit(hwnd,wParam,dlg_szEdit,MAX_SZEDIT,idc,0/*check_for_all_white_space*/))
					{
						double *view_array=idc==IDC_VIEW_TO?view_to:view_from;
 					FillDoubleArrayFromString(dlg_szEdit,view_array,1/*multiplier*/,WORLD_DIMENSION,0/*do_min*/);
						UpdateDialogEdits(1,hwnd,IDC_VIEWPOINT);
						EndProcessing(idc);
					}
					break;
			case IDC_VIEWPOINT_NAME:
				if(findszEdit(hwnd,wParam,dlg_szEdit,MAX_SZEDIT,IDC_VIEWPOINT_NAME,0/*check_for_all_white_space*/))
				{
					strcpy(szViewpointName,dlg_szEdit);
					UpdateDialogEdits(1,hwnd,IDC_VIEWPOINT);
					EndProcessing(idc);
				}
				break;
			case IDC_VIEW_FIELD_OF_VIEW:
				if(findszEdit(hwnd,wParam,dlg_szEdit,MAX_SZEDIT,IDC_VIEW_FIELD_OF_VIEW,1/*check_for_all_white_space*/))
				{
 				view_field_of_view=(double)slong_double(dlg_szEdit,view_field_of_view*angles_mult);
					view_field_of_view/=angles_mult;
					if(view_field_of_view<0)
					{
						view_field_of_view=DFT_VIEW_FIELD_OF_VIEW;
					}
					view_field_of_view=FastSetInRange(view_field_of_view,0,TWO_PI);
					UpdateDialogEdits(1,hwnd,IDC_VIEWPOINT);
					EndProcessing(idc);
				}
				break;
			case IDC_VIEW_TILT:
				if(findszEdit(hwnd,wParam,dlg_szEdit,MAX_SZEDIT,IDC_VIEW_TILT,1/*check_for_all_white_space*/))
				{
 				view_tilt=(double)slong_double(dlg_szEdit,view_tilt*angles_mult);
					view_tilt/=angles_mult;
					view_tilt=FastSetInRange(view_tilt,-PI,TWO_PI);
					UpdateDialogEdits(1,hwnd,IDC_VIEWPOINT);
					EndProcessing(idc);
				}
				break;
			}
			switch(idc)
			{
			case IDC_ABOUT:
				DialogBox (hInstance, TEXT ("About"), hwnd, AboutDlgProc);
				break;
			case IDC_OK:
				SendMessage(hwnd,WM_CLOSE,0,0);
				break;
			}
   idc_mid_update=0;
			break ;
		}
	 case WM_CLOSE:
			if(save_values)
				SaveIniFile(hwnd);
			else
				DeleteFile(szIniFile);
			EndDialog(hwnd,0);
			hDlgVRMLViewpoints=NULL;
			break;
	}
	return FALSE ;
}
