#include "VRML Viewpoints.h"

BOOL FileRead (PTSTR pstrFileName,PSTR szRead,int max_read)
{
     DWORD  dwBytesRead ;
     HANDLE hFile ;
     int    iFileLength;

          // Open the file.

     if (INVALID_HANDLE_VALUE == 
               (hFile = CreateFile (pstrFileName, GENERIC_READ, FILE_SHARE_READ,
                                    NULL, OPEN_EXISTING, 0, NULL)))
          return FALSE ;

          // Get file size in bytes and allocate memory for read.
          // Add an extra two bytes for zero termination.
                    
     iFileLength = GetFileSize (hFile, NULL) ; 
	 if(iFileLength<0)
		 return FALSE;

          // Read file and put terminating zeros at end.
     
     ReadFile (hFile, szRead, min(max_read-1,iFileLength), &dwBytesRead, NULL) ;
     CloseHandle (hFile) ;
     szRead[min(max_read-1,iFileLength)] = '\0' ;
     return TRUE ;
}

BOOL FileWrite (PTSTR pstrFileName,PTSTR pstrBuffer)
{
     DWORD  dwBytesWritten ;
     HANDLE hFile ;
	 int iLength=strlen(pstrBuffer) ;
     if (!pstrBuffer)
           return FALSE ;
          // Open the file, creating it if necessary
     
     if (INVALID_HANDLE_VALUE == 
               (hFile = CreateFile (pstrFileName, GENERIC_WRITE, 0, 
                                    NULL, CREATE_ALWAYS, 0, NULL)))
          return FALSE ;
     WriteFile (hFile, pstrBuffer, iLength* sizeof (TCHAR), 
                &dwBytesWritten, NULL) ;
     
     CloseHandle (hFile) ;
     if ((iLength * sizeof (TCHAR)) != (int) dwBytesWritten)
          return FALSE ;
     return TRUE ;
}

void SetIniDefaults(HWND hwnd)
{
	precision=DFT_PRECISION;
	viewpoint_height=DFT_VIEWPOINT_HEIGHT;
	view_field_of_view=DFT_VIEW_FIELD_OF_VIEW;
	view_tilt=DFT_VIEW_TILT;
	view_to[0]=view_to[1]=view_to[2]=0;//VRML defaults
	view_from[0]=view_from[1]=0;
	view_from[2]=10;
	strcpy(szViewpointName,"Viewpoint");
	angles_in=RADIANS;
}

#define NOT_THIS_ONE 0
#define IS_OK 1
#define END_OF_INPUT 2

char ResetEditFromIni(char *szRead,int *piPos,WORD idc,char *sz)
{
	if(sz[0]=='\0'||substrcmpUpperToWhiteSpace(&szRead[*piPos],TEXT(sz))==0)
		{
			int igpos=0;
			global_szEdit[0]='\0';
		 for(;;)
			{
				int i,igposwas=igpos;
				char new_line_needed=0;
				if(sz[0]!='\0')
				if(!next_token_pos_for_white_space(szRead,piPos))
					return END_OF_INPUT;
				if(szRead[*piPos]=='=')
					(*piPos)++;
			 *piPos+=copy_token_to_return(&global_szEdit[igpos],szRead,(*piPos),MAX_GLOBAL_SZEDIT-igpos);
				igpos=strlen(global_szEdit);
				for(i=igpos;i>igposwas;i--)
					if(global_szEdit[i]=='\\')
					{global_szEdit[i]='\0';igpos=i;new_line_needed=1;break;}
				if(!new_line_needed)
					break;
			}
			global_szEdit_ok=1;
	 	SendMessage(hDlgVRMLViewpoints,WM_COMMAND,MAKEWPARAM(idc,EN_UPDATE),0);
			global_szEdit_ok=0;
			return IS_OK;
		}
return NOT_THIS_ONE;
}

#define RESET_EDIT_FROM_INI(hwnd,idc,sz)\
{\
	cret=ResetEditFromIni(szRead,&iPos,idc,sz);\
	if(cret==END_OF_INPUT)goto finished;\
	if(cret==IS_OK)continue;\
}

char ReadIniFile(void)
{
	char szRead[READ_MAX];
	char cret=0;
	int iPos=-1;
	if(!FileRead(szIniFile,szRead,READ_MAX))
	{
		return 0;
	}
	for(;;)
	{
		if(!next_token_pos_for_white_space(szRead,&iPos))
			break;
		if(substrcmpUpperToWhiteSpace(&szRead[iPos],TEXT("angles_in"))==0)
 	{
			if(!next_token_pos_for_white_space(szRead,&iPos))
				goto finished;
			angles_in=(char)slong_double(&szRead[iPos+1],angles_in);
			SET_ANGLES_MULT
		}
		RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_PRECISION,"precision")
		RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEW_FIELD_OF_VIEW,"view_field_of_view")
		RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEWPOINT_NAME,"szViewpointName")
		RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEWPOINT_HEIGHT,"viewpoint_height")
		RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEW_TILT,"view_tilt")
	 RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEW_TO,"view_to")
	 RESET_EDIT_FROM_INI(hDlgViewpoints,IDC_VIEW_FROM,"view_from")
	}
finished:;
	UpdateDialogEdits(0,0,0);
 return 1;
}

char SaveIniFile(HWND hwnd)
{
	char szWrite[READ_MAX];
	UINT uText=0;
	char return_value=0;
	char *szS="";
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sprecision =%d _needs_to_be_first",szS,precision);
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sangles_in =%d _needs_to_before_any_of_the_angles_",szS,angles_in);
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sszViewpointName =%s",szS,szViewpointName);
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sview_from =",szS);strcatFloatArray(&uText,READ_MAX,szWrite,view_from,1/*multiplier*/,1/*first_value_only_if_repeats*/,WORLD_DIMENSION);
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sview_to =",szS);strcatFloatArray(&uText,READ_MAX,szWrite,view_to,1/*multiplier*/,1/*first_value_only_if_repeats*/,WORLD_DIMENSION );
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sview_tilt =%.*g",szS,precision,view_tilt);
	strcatsprintf(&uText,READ_MAX,szWrite,"\n%sview_field_of_view =%.*g",szS,precision,view_field_of_view*angles_mult);
	return_value=FileWrite(szIniFile,szWrite);
	return return_value;
}
